package main

import (
	"io"
	"log"

	"github.com/baidubce/bce-cfc-go/pkg/cfc"
)

func init() {
	// 注册Handler
	cfc.RegisterNamedHandler("echo_handler", &EchoHandler{})
}

type EchoHandler struct{}

func (h *EchoHandler) Handle(input io.Reader, output io.Writer, context cfc.InvokeContext) error {
	log.Printf("reqid=%s, brn=%s, name=%s, ver=%s, mem=%d\n",
		context.GetRequestID(), context.GetFunctionBrn(), context.GetFunctionName(),
		context.GetFunctionVersion(), context.GetMemoryLimitMB())
	credential := context.GetCredential()
	if credential != nil {
		log.Printf("ak=%s, sk=%s, token=%s\n",
			credential.AccessKeyId, credential.AccessKeySecret, credential.SessionToken)
	}
	_, err := io.Copy(output, input)
	return err
}
